@echo off & setlocal enableextensions enabledelayedexpansion

echo Ŀ
echo  SAMENAME.CMD Scan folders for files with the same name 
echo  By Prof. Timo Salmi. Last modified Sat 31-Dec-2005     
echo 
echo.
rem  Includes subfolders, if any, in the search

:: Usage
if "%~2"=="" (
  echo Usage %~0 "Folder1" "Folder2"
  if not defined cmdbox if defined PauseIfFromDesktop pause
  goto :EOF)

:: Temporary files
set temp_=%temp%
if defined mytemp set temp_=%mytemp%
set tempfil1_="%temp_%\samefil1.$$$"
set tempfil2_="%temp_%\samefil2.$$$"
for %%f in (%tempfil1_% %tempfil2_%) do if exist %%f del %%f

:: Get the folders from the command line
set folder1_=%~1
set folder2_=%~2
if not exist "%folder1_%" (
  echo Folder "%folder1_%" not found
  goto :EOF)
if not exist "%folder2_%" (
  echo Folder "%folder2_%" not found
  goto :EOF)

:: Make directory listings for both the folders and their subfolders
for /f "delims=" %%f in ('dir /a:-d /b /o:n /s "%folder1_%\*.*"') do (
   echo %%~nf%%~xf,%%~tf,%%~zf,%%~dpf>>%tempfil1_%
   )
for /f "delims=" %%f in ('dir /a:-d /b /o:n /s "%folder2_%\*.*"') do (
   echo %%~nf%%~xf,%%~tf,%%~zf,%%~dpf>>%tempfil1_%
   )

:: Sort in order to merge the results
sort %tempfil1_%>%tempfil2_%

:: Display only if the filename repeats, i.e. skip the "lonely" files
for /f "tokens=1-4 delims=," %%a in ('type %tempfil2_%') do (
  if "!preva_!"=="%%a" (
    set same_=true
    if not "!prevb_!"=="%%b" set same_=false
    if not "!prevc_!"=="%%c" set same_=false
    if "!same_!"=="true" (
      echo !preva_! !prevb_! !prevc_! !prevd_!
      ) else (
      echo * !preva_! !prevb_! !prevc_! !prevd_! ^(differs^))
    echo %%a %%b %%c %%d
    )
  set preva_=%%a
  set prevb_=%%b
  set prevc_=%%c
  set prevd_=%%d
)

:: Clean up
for %%f in (%tempfil1_% %tempfil2_%) do if exist %%f del %%f
endlocal & goto :EOF
